//+------------------------------------------------------------------+
//|                                           IchimokuHisto_v1.2.mq4 |
//|                                Copyright  2013, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
// List of Prices:
// Price    = 0 - Close  
// Price    = 1 - Open  
// Price    = 2 - High  
// Price    = 3 - Low  
// Price    = 4 - Median Price   = (High+Low)/2  
// Price    = 5 - Typical Price  = (High+Low+Close)/3  
// Price    = 6 - Weighted Close = (High+Low+Close*2)/4

 
#property copyright "Copyright  2013, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1  RoyalBlue
#property indicator_color2  Crimson
#property indicator_color3  Gray

#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0

//---- indicator parameters

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int     Tenkan               =     9;    // Tenkan period 
extern int     Kijun                =    26;    // Kijun period
extern int     Senkou               =    52;    // Senkou period
extern double  IndicatorValue       =     1;


//---- indicator buffers
double upTrend[];
double dnTrend[];
double neutral[];
//----
string TF, IndicatorName, short_name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorDigits(1);
   
//---- indicator buffers mapping
   SetIndexBuffer(0,upTrend); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnTrend); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,neutral); SetIndexStyle(2,DRAW_HISTOGRAM);  
   
//---- indicator name
   switch(Period())
   {
   case 1     : TF = "M1" ; break;
   case 5     : TF = "M5" ; break;
   case 15    : TF = "M15"; break;
   case 30    : TF = "M30"; break;
   case 60    : TF = "H1" ; break;
   case 240   : TF = "H4" ; break;
   case 1440  : TF = "D1" ; break;
   case 10080 : TF = "W1" ; break;
   case 43200 : TF = "MN1"; break;
   } 

   IndicatorName = WindowExpertName(); 
   short_name = IndicatorName + "[" + TF + "]("+ Tenkan + "," + Kijun + "," + Senkou + ")";
   IndicatorShortName(short_name);
       
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DnTrend");
   SetIndexLabel(2,"Neutral");
   
   int draw_begin = Senkou;
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);
   TimeFrame = MathMax(TimeFrame,_Period);
//---- initialization done 
  
   return(0);
}
//+------------------------------------------------------------------+
//| IchimokuHisto_v1.2                                               |
//+------------------------------------------------------------------+
int start()
{
   int limit, i, shift, counted_bars = IndicatorCounted(); 
   
   
   if(counted_bars > 0) limit = MathMin(MathMax(Bars - counted_bars - 1,2*TimeFrame/_Period),Bars-1);
   if(counted_bars < 0) return(0);
   if(counted_bars < 1)
   { 
   limit = Bars - 1;   
      for(i=limit;i>=0;i--) 
      {
      upTrend[i] = EMPTY_VALUE;
      dnTrend[i] = EMPTY_VALUE;
      neutral[i] = EMPTY_VALUE;
      }
   }   
   
   for(shift=limit;shift>=0;shift--) 
   {
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      double chinkou = iIchimoku(NULL,TimeFrame,Tenkan,Kijun,Senkou,MODE_CHINKOUSPAN,y+Kijun);
      
   
   upTrend[shift] = EMPTY_VALUE;
   dnTrend[shift] = EMPTY_VALUE;    
   neutral[shift] = EMPTY_VALUE; 
      
      if(chinkou > iHigh(NULL,TimeFrame,y+Kijun)) upTrend[shift] = IndicatorValue;
      else
      if(chinkou < iLow(NULL,TimeFrame,y+Kijun)) dnTrend[shift] = IndicatorValue;
      else neutral[shift] = IndicatorValue;
                 
   }

   return(0);
}

//-----


